//+-------------------+
//| CCFp order script |
//|-------------------+

#property copyright "Ron Thompson 2008"
#property link      "http://www.ForexMT4.com/"

// This code is NEVER to be SOLD individually 
// This code is NEVER to be INCLUDED as part of a collection that is SOLD


//user input
#property show_inputs

extern string StrengtheningBases =         "AUD,CAD,NZD" ;
extern string WeakeningBases     =         "USD,EUR,GBP,CHF,JPY" ;
//extern string Pairs              =         "AUDJPY,AUDNZD,AUDUSD,CADJPY,CHFJPY,EURAUD,EURCAD,EURCHF,EURDKK,EURGBP,EURJPY,EURNOK,EURSEK,EURUSD,EURZAR,GBPCAD,GBPCHF,GBPJPY,GBPUSD,NZDJPY,NZDUSD,USDCAD,USDCHF,USDDKK,USDJPY,USDMXN,USDNOK,USDSEK,USDSGD,USDTHB,USDZAR" ;
extern string Pairs              =         "AUDCADm,AUDCHFm,AUDJPYm,AUDNZDm,AUDUSDm,CHFJPYm,EURAUDm,EURCADm,EURCHFm,EURGBPm,EURJPYm,EURNZDm,EURUSDm,GBPCADm,GBPCHFm,GBPJPYm,GBPNZDm,GBPUSDm,NZDCHFm,NZDJPYm,NZDUSDm,USDCADm,USDCHFm,USDJPYm" ;
extern double Lots               =           0.2 ;
extern double LossLimit          =           0   ;
extern double ProfitMade         =           0   ;



// Script specific
//string        mySymbol;
double        bid;
double        ask;
double        myPoint;                              // support for 3/5 decimal places
int           Slippage=2;                           // how many pips of slippage can you tolorate
int           loopcount;                            // count of order attempts
int           maxloop=3;                            // maximum number of attempts to handle errors
int           LL2SL=50;                             // LossLimit to StopLoss server spread
int           MagicNumber  = 200810121510;          // allows multiple experts to trade on same account
string        TradeComment = "_CCFporders.txt";     // for order comments

string Pairz[100];
int    ptrPMAX;
string sbase[100];
int    ptrSMAX;
string wbase[100];
int    ptrWMAX;

int    ptrPairz=0;





// used for verbose error logging
#include <stdlib.mqh>




//+-------------+
//| Custom init |
//|-------------+
// Called ONCE when EA is added to chart or recompiled

int init()
  {
   // ptr*MAX is used as a counter in INIT so that when 
   // INIT is complere, ptrPMAX will be equal to the 
   // last element count 
      
   int i,j;
   int cnt;
   string cmt;

   // Split the user string into an array 
   int pcomma;
   int comma;


   //clear the arrays 
   for (i=0; i<100; i++)
     {
      // in case there were previous data
      Pairz[i]="";
      sbase[i]="";
      wbase[i]="";
     }


   //
   //
   // Pairs
   //
   //
   pcomma=0;
   comma=0;
   ptrPMAX=0;
   
   // (empty or garbage) then set array to current symbol only
   if(StringLen(Pairs)<6)
     {
      Pairz[0]=Symbol();
      ptrPMAX=1;
      Print("---EMPTY/CORRUPTED--- PAIR Array set to single element of this pair");
     }

   
   //Load all of the symbols
   while ( StringLen(Pairs)>=6 )
     {
      //save the old comma
      pcomma=comma;
      // find the next comma
      comma=StringFind(Pairs, ",", pcomma+1);

      // Gather trailing(or only) pair 
      // (no comma following last/only pair)
      // then leave (accounts for one pair on line)
      if(comma<0)
        {
         Pairz[ptrPMAX]=StringSubstr(Pairs, pcomma+1, comma-pcomma);
         Print("PAIR--"+ptrPMAX+" "+Pairz[ptrPMAX]+"   --- LAST PAIR ---");      
         break;
        }
      // store the pair into an array
      if(ptrPMAX==0) Pairz[ptrPMAX]=StringSubstr(Pairs, pcomma, comma-pcomma);
      if(ptrPMAX >0) Pairz[ptrPMAX]=StringSubstr(Pairs, pcomma+1, comma-pcomma-1);
      
      Print("PAIR--"+ptrPMAX+" "+Pairz[ptrPMAX]);      
      
      // increment pointer for next elemant
      ptrPMAX++;
      if(ptrPMAX>100) break;
     }//while
   
   
   //
   //
   // Strengthening
   //
   //
   pcomma=0;
   comma=0;
   ptrSMAX=0;
   
   // (empty or garbage) then set array to current symbol only
   if(StringLen(StrengtheningBases)<3)
     {
      sbase[0]="XXX";
      ptrSMAX=1;
      Print("---EMPTY/CORRUPTED--- WeakBase Array set to XXX");
     }

   
   //Load all of the symbols
   while ( StringLen(StrengtheningBases)>=3 )
     {
      //save the old comma
      pcomma=comma;
      // find the next comma
      comma=StringFind(StrengtheningBases, ",", pcomma+1);

      // Gather trailing(or only) pair 
      // (no comma following last/only pair)
      // then leave (accounts for one pair on line)
      if(comma<0)
        {
         sbase[ptrSMAX]=StringSubstr(StrengtheningBases, pcomma+1, comma-pcomma);
         Print("STRONG--"+ptrSMAX+" "+sbase[ptrSMAX]+"   --- LAST STRONG ---");      
         break;
        }
      // store the pair into an array
      if(ptrSMAX==0) sbase[ptrSMAX]=StringSubstr(StrengtheningBases, pcomma, comma-pcomma);
      if(ptrSMAX >0) sbase[ptrSMAX]=StringSubstr(StrengtheningBases, pcomma+1, comma-pcomma-1);
      
      Print("STRONG--"+ptrSMAX+" "+sbase[ptrSMAX]);      
      
      // increment pointer for next elemant
      ptrSMAX++;
      if(ptrSMAX>100) break;
     }//while

   

   //
   //
   // Weakening
   //
   //
   pcomma=0;
   comma=0;
   ptrWMAX=0;
   
   // (empty or garbage) then set array to current symbol only
   if(StringLen(WeakeningBases)<3)
     {
      wbase[0]="XXX";
      ptrWMAX=1;
      Print("---EMPTY/CORRUPTED--- WeakBase Array set to XXX");
     }

   
   //Load all of the symbols
   while ( StringLen(WeakeningBases)>=3 )
     {
      //save the old comma
      pcomma=comma;
      // find the next comma
      comma=StringFind(WeakeningBases, ",", pcomma+1);

      // Gather trailing(or only) pair 
      // (no comma following last/only pair)
      // then leave (accounts for one pair on line)
      if(comma<0)
        {
         wbase[ptrWMAX]=StringSubstr(WeakeningBases, pcomma+1, comma-pcomma);
         Print("WEAK--"+ptrWMAX+" "+wbase[ptrWMAX]+"   --- LAST WEAK ---");      
         break;
        }
      // store the pair into an array
      if(ptrWMAX==0) wbase[ptrWMAX]=StringSubstr(WeakeningBases, pcomma, comma-pcomma);
      if(ptrWMAX >0) wbase[ptrWMAX]=StringSubstr(WeakeningBases, pcomma+1, comma-pcomma-1);
      
      Print("WEAK--"+ptrWMAX+" "+wbase[ptrWMAX]);      
      
      // increment pointer for next elemant
      ptrWMAX++;
      if(ptrWMAX>100) break;
     }//while
   
      
   Comment(" ");
   Print("Init complete - script");
  }

//+----------------+
//| Custom DE-init |
//+----------------+
// Called ONCE when EA is removed from chart

int deinit()
  {
   Comment(" ");
   Print("DE-Init complete - script");
  }


//+-----------+
//| Main      |
//+-----------+
// Called EACH TICK and each Bar[]
int start()
  {
   int i,j,k;
   bool hasStrong,hasWeak;
   string strStrong,strWeak;
   int pos;

   //look through available pairs
   for(i=0; i<=ptrPMAX; i++)
     {
      
      // does this pair have any strong base
      hasStrong=false;
      for(j=0; j<=ptrSMAX; j++)
        {
         if(StringFind(Pairz[i],sbase[j])>=0) 
           {
            hasStrong=true;
           }
        }


      // does this pair have any weak base
      hasWeak=false;
      for(k=0; k<=ptrWMAX; k++)
        {
         if(StringFind(Pairz[i],wbase[k])>=0)  
           { 
            hasWeak=true; 
           }
        }


      // does it have one of each
      if(hasStrong && hasWeak)
        {
         for(j=0; j<=ptrSMAX; j++)
           {
            //if( StringFind(Pairz[i],sbase[j])==0)  Print( "BUY  "+Pairz[i] );        
            //if( StringFind(Pairz[i],sbase[j])==3)  Print( "SELL "+Pairz[i] );        
            if( StringFind(Pairz[i],sbase[j])==0)  OpenBuy(Pairz[i]);        
            if( StringFind(Pairz[i],sbase[j])==3)  OpenSell(Pairz[i]);        
           }

        }//if

     }//for
     
  } // start()







//ENTRY LONG (buy, Ask) 
void OpenBuy(string buySymbol)
     {
      int      gle=0;
      int      ticket=0;
      
      double SL=0;
      double TP=0;
      int loopcount;

      // PLACE order is independent of MODIFY order. 
      // This is mandatory for ECNs and acceptable for retail brokers

      loopcount=0;
      while(true)          
        {
         bid=MarketInfo(buySymbol,MODE_BID);
         ask=MarketInfo(buySymbol,MODE_ASK);

         // place order - NO TP OR SL
         ticket=OrderSend(buySymbol,OP_BUY,Lots,ask,Slippage,0,0,TradeComment,MagicNumber,White);
         gle=GetLastError();
         if(gle==0)
           {
            Print("BUY PLACED Ticket="+ticket+" Ask="+ask+" Lots="+Lots);
            break;
           }
          else 
           {
            Print("-----ERROR-----  Placing BUY order: Lots="+Lots+" Bid="+bid+" Ask="+ask+" ticket="+ticket+" Err="+gle+" "+ErrorDescription(gle)); 
            
            RefreshRates();
            Sleep(500);

            // give up after loopcount tries
            loopcount++;
            if(loopcount>maxloop)
              {
               Print("-----ERROR-----  Giving up on placing BUY order"); 
               return(gle);
              }
           }
        }//while - place order 


      // modify the order for users TP & SL
      loopcount=0;
      while(true)
        {
         bid=MarketInfo(buySymbol,MODE_BID);
         ask=MarketInfo(buySymbol,MODE_ASK);

         // don't set TP and SL both to zero, they're already there
         if(LossLimit==0 && ProfitMade==0) break;
         
         if(LossLimit  ==0) SL=0;
         if(ProfitMade ==0) TP=0;
         if(LossLimit   >0) SL=ask-((LossLimit+LL2SL)*myPoint );
         if(ProfitMade  >0) TP=ask+((ProfitMade+LL2SL)*myPoint );
         OrderModify(ticket,OrderOpenPrice(),SL,TP,0,White);
         gle=GetLastError();
         if(gle==0)
           {
            Print("BUY OPENMOD Ticket="+ticket+" Ask="+ask+" Lots="+Lots+" SL="+SL+" TP="+TP);
            break;
           }
          else 
           {
            Print("-----ERROR-----  Modifying BUY order: Lots="+Lots+" SL="+SL+" TP="+TP+" Bid="+bid+" Ask="+ask+" ticket="+ticket+" Err="+gle+" "+ErrorDescription(gle)); 
            
            RefreshRates();
            Sleep(500);

            loopcount++;
            if(loopcount>maxloop)
              {
               Print("-----ERROR-----  Giving up on modifying BUY order"); 
               return(gle);
              }
           }
        }//while - modify order
        
        
     }//BUYme



   //ENTRY SHORT (sell, Bid)
void OpenSell(string sellSymbol)
     {
      int      gle=0;
      int      ticket=0;
      
      double SL=0;
      double TP=0;
      int loopcount;

      // PLACE order is independent of MODIFY order. 
      // This is mandatory for ECNs and acceptable for retail brokers

      loopcount=0;
      while(true)
        {
         bid=MarketInfo(sellSymbol,MODE_BID);
         ask=MarketInfo(sellSymbol,MODE_ASK);

         ticket=OrderSend(sellSymbol,OP_SELL,Lots,bid,Slippage,0,0,TradeComment,MagicNumber,Red);
         gle=GetLastError();
         if(gle==0)
           {
            Print("SELL PLACED Ticket="+ticket+" Bid="+bid+" Lots="+Lots);
            break;
           }
            else 
           {
            Print("-----ERROR-----  placing SELL order: Lots="+Lots+" SL="+SL+" TP="+TP+" Bid="+bid+" Ask="+ask+" ticket="+ticket+" Err="+gle+" "+ErrorDescription(gle)); 
                            
            RefreshRates();
            Sleep(500);

            loopcount++;
            if(loopcount>maxloop)
              {
               Print("-----ERROR-----  Giving up on placing SELL order"); 
               return(gle);
              }
           }
        }//while

      
      // modify the order for users TP & SL
      loopcount=0;
      while(true)
        {
         bid=MarketInfo(sellSymbol,MODE_BID);
         ask=MarketInfo(sellSymbol,MODE_ASK);

         // don't set TP and SL both to zero, they're already there
         if(LossLimit==0 && ProfitMade==0) break;
         
         if(LossLimit  ==0) SL=0;
         if(ProfitMade ==0) TP=0;
         if(LossLimit   >0) SL=bid+((LossLimit+LL2SL)*myPoint );
         if(ProfitMade  >0) TP=bid-((ProfitMade+LL2SL)*myPoint );
         OrderModify(ticket,OrderOpenPrice(),SL,TP,0,Red);
         gle=GetLastError();
         if(gle==0)
           {
            Print("SELL OPENMOD Ticket="+ticket+" Bid="+bid+" Lots="+Lots+" SL="+SL+" TP="+TP);
            break;
           }
            else 
           {
            Print("-----ERROR-----  modifying SELL order: Lots="+Lots+" SL="+SL+" TP="+TP+" Bid="+bid+" Ask="+ask+" ticket="+ticket+" Err="+gle+" "+ErrorDescription(gle)); 
                            
            RefreshRates();
            Sleep(500);

            loopcount++;
            if(loopcount>maxloop)
              {
               Print("-----ERROR-----  Giving up on placing SELL order"); 
               return(gle);
              }
           }

        }//while

     }//SELLme




